'
' ==================================================================
'  frmScanRqExe :    Detects Libray Type in RapidQ Executable
'  Jacques                                          April 16th, 2005 
' ==================================================================
'
$Include "QDir.Inc"
Dim myDir As QDir
$INCLUDE "QInputBox.Inc"
Dim myInput As QInputBox
' Hash Function                        see  WARNING.TXT
$Include "Hash32BitBin.Rqh"            ' .inc works too
$Include "QBrowseDialog.Inc"
Dim myBrowserDir AS QBrowseDialog
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
Declare Function CheckKnownLib (iHash As Integer) As Long
Declare Function GetRootDirToScan () As String
Declare Function GetLibrary (file as String) as String
Declare Sub OnFileFound_QDir
Declare Function AlignString (iLength As Long, sDatas As String) As String
'
Declare Sub OnClose_frmScanRqExe
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
'
Create frmScanRqExe As QForm
    Center
    Width = 1000
    height = 800
    Caption = "frmScanRqExe Detects Library Type in RapidQ Executable"
    AutoScroll = False
    OnClose = OnClose_frmScanRqExe
    Create rchWin AS QRichEdit  ' will disply the received datas
        Align = 5
        Font.Name = "courier"
        Font.Size = 8
        Font.Color = &H800000
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False
        PlainText = True
    End Create
    Create mnuMain AS QMAINMENU
        Create mnuScanForLibs AS QMENUITEM
            Caption = "SCAN_DIR/S_FOR_&LIBS     "
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuScanForExes AS QMENUITEM
            Caption = "SCAN_DIR/S_FOR_EXES     "
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuCheckOneExe AS QMENUITEM
            Caption = "CHECK_ONE_SINGLE_EXES     "
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuResetCounts AS QMENUITEM
            Caption = "RESET_COUNTS_IN_KNOWNLIBS     "
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuFontSize AS QMENUITEM
            Caption = "FONT SIZE     "
            OnClick = OnClic_AnyMenu
        End Create
    End Create
End Create
'
' --------------------------------------------------------------------
' New Code API Call that lets RapidQ programs minimize to the task bar
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, _
                                               nIndex AS LONG, dwNewLong AS LONG) AS LONG
'      ----- API Constants and Functions
CONST GWL_HWNDPARENT = (-8)                   'Minimize to task bar
CONST HWND_DESKTOP = 0
setwindowlong(frmScanRqExe.handle, GWL_HWNDPARENT, HWND_DESKTOP)
setwindowlong(application.handle, GWL_HWNDPARENT, frmScanRqExe.handle)
' --------------------------------------------------------------------
DefInt flagMenuBusy = False
'
' *************************************
frmScanRqExe.Show
' *************************************
' List of Known Group Libraries
' Format .item(N) = Hex$(HashValue) & "*" & LibName & "*" & LibGroupName & "*" & iLibLength & "*" & iCount
Dim slKnownLibs As QStringList
' INITIALISATION
' --------------
If FileExists ("KnownLibs.Slst") <> 0 Then
    slKnownLibs.LoadFromFile ("KnownLibs.Slst")
Else      ' create empty if dont exist
    If MessageDlg("NO REFERENCE LIBRARY LIST \"KnownLibs.Slst\" PRESENT", mtWarning, mbOk OR mbCancel, 0) = IdCancel Then
        Application.Terminate
        End
    End If
End If
'
DefStr sRootDir, sInitDir = Command$(0) - ("\\" & Application.Exename)     
'
DefInt iLibLength, iMatchCount, iFoundCount = 0
' Set QDir Event
myDir.OnFileFound = OnFileFound_QDir  '( FileFound Event)
' Start Scanning For .Exe in sRootDir and subdirectories
DefStr flagScan
'
RchWin.AddString "\n     YOU SHOULD FIRST AND ONLY ONCE SCAN THE DIRECTORIES" _
               & "\n     OF YOUR RAPIDQ LIBRARIES TO INITIALISE THE \"slKnownLibs\" LIST." _
               & "\n     IF YOU HAVE UNKNOWN LIBRARIES IT WOULD BE NICE TO BROADCAST YOUR" _
               & "\n     \"KnownLibs.Slst\" FILE." _
             & "\n\n     THEN SCAN ALL YOUR DIRECTORIES CONTAINING RAPIDQ EXECUTABLE TO" _
               & "\n     CHECK FOR NEW LIBRARY BUILT IN THE EXECUTABLES ..." _
             & "\n\n     A RapidQ Executable is a ByteCode appended as a Resource" _
               & "\n     to one of the RapidQ Libraries ; then the size of the bytecode" _
               & "\n     is appended to the result. Here we extract the Libraries from" _
               & "\n     the Executable and we cut the last 4000 bytes from it to avoid" _
               & "\n     icons differences. To compare Libraries, a Hash value is computed" _
               & "\n     for each library found in exe and stored in \"slKnownLibs\" with" _
               & "\n     other file informations if the included library is unknown." _
             & "\n\n     Limitations :" _
               & "\n     - files larger than 500Kbytes and smaller than 150Kbytes, are" _
               & "\n       not checked. " _
               & "\n     - RapidQ file containing many Resources may be erroneously " _
               & "\n       declared \"UNKNOWN\"." _
             & "\n\n     With this, its possible to know which RapidQ Library of which" _
               & "\n     source was used to build an Executable even if it's not one of" _
               & "\n     yours." _
             & "\n\n     April the 15th, 2005"

' *************************************
frmScanRqExe.Visible = False
frmScanRqExe.ShowModal
' *************************************
'
Sub OnClose_frmScanRqExe
    Application.Terminate
    End
End Sub
'
Sub OnClic_AnyMenu (Sender As QMenuItem)
    DefStr sFile
    DefInt N, iLen, flagSpace, iDir = 0
    If flagMenuBusy = True Then Exit Sub
    flagMenuBusy = true
    Select Case Sender.Handle
        Case mnuScanForLibs.Handle
            ' Get Root Scan Directory
            sRootDir = GetRootDirToScan
            If MessageDlg("SURE YOU WANT TO SCAN\n\n" & sRootDir & "\n\nFOR .LIB ????\n\n(HARMLESS, ONLY READS THE FILES, NO REWRITE)", mtConfirmation, mbYes OR mbCancel, 0) = IdCancel Then
                flagMenuBusy = False
                Exit Sub
            End If
            rchWin.Addstring "\n\n =====================================================================================" _
                           & "\n\n SCANNING DIRECTORY : \"" & sRootDir & "\"  FOR LIBRARIES  .LIB (RAPIDQ ONES PREFERABLY)\n\n"
            flagScan = "lib"
            myDir.Dirs (sRootDir & "*.Lib", "D", "")  ' arg2 rejected, arg3 mustAttributes
        Case mnuScanForExes.Handle
            ' Get Root Scan Directory
            sRootDir = GetRootDirToScan
            If MessageDlg("SURE YOU WANT TO SCAN\n\n" & sRootDir & "\n\nFOR .EXE ????\n\n(HARMLESS, ONLY READS THE FILES, NO REWRITE)", mtConfirmation, mbYes OR mbCancel, 0) = IdCancel Then
                flagMenuBusy = False
                Exit Sub
            End If
            rchWin.Addstring "\n\n =====================================================================================" _
                           & "\n\n SCANNING DIRECTORY : \"" & sRootDir & "\"  FOR EXEFCUTABLES  .EXE (NOT ONLY RAPIDQ ONES)\n\n"
            flagScan = "exe"
            myDir.Dirs (sRootDir & "*.Exe", "D", "")  ' arg2 rejected, arg3 mustAttributes
        Case mnuCheckOneExe.Handle
            Dim dlgOpen AS QOpenDialog
            DefStr sOldDir
            dlgOpen.Filter = "Exe files|*.Exe|All Files|*.*"
            dlgOpen.FilterIndex = 1
            sOldDir = CurDir$
            dlgOpen.InitialDir = sInitDir
            If dlgOpen.Execute Then
                flagScan = "exe"
                myDir.Dirs (dlgOpen.FileName, "D", "")  ' arg2 rejected, arg3 mustAttributes
                sInitDir = Left$(dlgOpen.FileName, RInstr (dlgOpen.FileName, "\\") - 1)
            End If
            ChDir sOldDir
        Case mnuResetCounts.Handle
          With slKnownLibs
            If MessageDlg("SURE YOU WANT TO RESET ALL THE\n\nLIBRARY OCCURENCE COUNTER ?", mtConfirmation, mbYes OR mbCancel, 0) = IdYes Then
                For N = 0 To .ItemCount - 1
                    .Item(N) = Left$(.Item(N), RInstr(.Item(N), "*")) & "0"
                Next N
                slKnownLibs.SaveToFile ("KnownLibs.Slst")
                ShowMessage ("ALL COUNTERS ARE RESET")
            End If
          End With
            flagMenuBusy = False
            Exit Sub
        Case mnuFontSize.Handle
            If rchWin.Font.Size = 8 Then
                rchWin.Font.Size = 12
            Else
                rchWin.Font.Size = 8
            End If
            flagMenuBusy = False
            Exit Sub
    End Select
    slKnownLibs.SaveToFile ("KnownLibs.Slst")
    rchWin.SaveToFile (UCase$(flagScan) & "Scan_" & (Time$ - ":") & ".txt")
    rchWin.Addstring ("\n\n *** SCAN FOR " & UCASE$ (flagScan) & "  FINISHED  ***")
    Sound 3000, 5
    flagMenuBusy = False
End Sub
' ---- SUBs and FUNCTIONs -------------------------------------
Function GetRootDirToScan () As String
    With myBrowserDir
        .Caption = "RapidQ Root Dir To Scan With its Sub Dir For " & Ucase$(flagScan)
        .Title = "SELECT A DIRECTORY TO SCAN WITH SUB DIRS FOR" & Ucase$(flagScan)
        .InitialDir = sInitDir
        If .Execute = True Then
            sInitDir = .Directory
            Result = sInitDir & "\\"
        Else
            ShowMessage ("  *** ERROR : CANT EXECUTE QBROWSEDIALOG")
            Result = ""
        End If
    End With
End Function
' -------------------------------------------------------------
Function CheckKnownLib (iHash As Integer) As Long
    DefInt N, iCount, iMatch = - 1
    iMatchCount = 0
    DefStr sHash = Hex$(iHash), sGroupName
  With slKnownLibs
    For N = 0 To .ItemCount - 1
        If sHash = Field$(.Item(N), "*", 1) Then
            iCount = Val(Field$(.Item(N), "*", 5))
            Inc iCount
            .Item(N) = Left$(.Item(N), RInstr(.Item(N), "*")) & Str$(iCount)
            Result = N
            iMatch = N
            Inc iMatchCount
        End If
    Next N
    Result = iMatch
  End With
End Function
' -------------------------------------------------------------
Function GetLibrary (file as String) as String
    DefStr sFile = file, sTmp
    DefInt iFileSize, iResourceLength
    Dim fileIN AS QFileStream
    fileIn.Open (sFile, fmOpenRead)
        If flagScan = "exe" Then
            fileIn.Position = fileIn.Size - 4
            fileIn.Read (iResourceLength)
            iLibLength = fileIn.Size - iResourceLength - 4
            fileIn.Position = 0
            Result = fileIn.ReadBinStr (iLibLength - 4000)   ' cut 1412 the icon out
        Else  ' = "lib"
            iLibLength = fileIn.Size
            Result = fileIn.ReadBinStr (iLibLength - 4000)
        End If
    fileIn.close
End Function
'
' QDir OnFileFound Event
Sub OnFileFound_QDir
    DefInt iSize = myDir.Size, iHash, i, iCount, iPtr, j
    DefStr sLib, sGroupName, sFileName, sLine, sTmp
    If (iSize > 500000 Or iSize < 150000) Then Exit Sub   ' Very very probably not an RQ Exe
    sLib = GetLibrary (myDir.PathFileName)
    iHash = Hash32BitBin (VarPtr(slib))
    i = checkKnownLib (iHash)  ' i = index in slKnownLibs pointing known lib
    sLine = ""
    Inc iFoundCount
    If iFoundCount Mod 10 = 1 Then
        sLine =  String$(130, 45) & "\n" & "                 " _
        & AlignString (25, "FILE NAME") & AlignString (25, "build with   LIB NAME") _
        & AlignString (25, "from   GROUP NAME") & AlignString (10, "LIB SIZE") _
        & AlignString (6,  "COUNT") & "   FILE FULL PATH/FILENAME" _
        & "\n" & String$(130, 45) & "\n"
    End If
    If i <> - 1 Then      ' KNOWN LIBS
         sLine = sLine & "  KNOWN LIB IN : "
    Else                  ' UNKNOWN LIBS
        iPtr = Tally (myDir.PathFileName, "\\")
        If iPtr > 0 Then
            sFileName  = myDir.FileName
            sGroupName = myDir.PathFileName - sFileName
        End If
        If  iPtr > 1 Then
            sGroupName = Mid$(sGroupName, RInstr(Len(sGroupName) - 1, sGroupName, "\\"))
            sGroupName = sGroupName - "\\"
        ElseIf iPtr = 1 THen
            sGroupName = sGroupName - "\\"
        Else
            sGroupName = myDir.PathFileName
            sFileName = myDir.PathFileName
        End If
        sGroupName = Left$(sGroupName, 23)
        sFileName = Left$(sFileName, 23)
        slKnownLibs.AddItems (Hex$(iHash) & "*" & sFileName & "*" & sGroupName & "*" & Str$(iLibLength) & "*1")
        i = slKnownLibs.Itemcount - 1
        sLine = sLine & "UNKNOWN LIB IN : "
    End If
    sTmp = 
    sLine = sLine & _
           & AlignString (25, Right$(MyDir.FileName, 23)) _
           & AlignString (25, Field$ (slKnownLibs.Item (i), "*", 2)) _
           & AlignString (25, Field$ (slKnownLibs.Item (i), "*", 3)) _
           & AlignString (10, Field$ (slKnownLibs.Item (i), "*", 4)) _
           & AlignString (6,  Field$ (slKnownLibs.Item (i), "*", 5)) _
           & "   " & MyDir.PathFileName
    rchWin.Addstring sLine
'    
    If iMatchCount > 1 Then
        ShowMessage ("MULTIPLE MATCHING LIBRARIES FOR " & myDir.PathFileName & " (... -2000)")
        rchWin.Addstring  ("          MULTIPLE MATCHING LIBRARIES FOR " & myDir.PathFileName & " (... -2000)")
    End If
'    ShowMessage ("END ON FOUND")
End sub
'
Function AlignString (iLength As Long, sDatas As String) As String   ' align Right
    DefStr sTmp, sTmp2
    sTmp = Space$(iLength)
    sTmp2 = sDatas
    Result = Replace$(sTmp, sTmp2, iLength + 1 - Len(sTmp2))
End Function
'
